package com.eactive.eai.batch.job.jobItem.bokjj;

import java.io.ByteArrayOutputStream;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_BOKJJ_0610 extends DefaultTelegram implements TelegramService {

    //>> 업무관리정보
    private final String OpCode_start      = "001";    //개별 업무 개시
    private final String OpCode_resume     = "002";    //파일 송수신 계속
    private final String OpCode_unit_end   = "003";    //개별업무 종료
    private final String OpCode_all_end    = "004";    //전체업무 종료

    /**
     * 생성자
     */
    public RECV_BOKJJ_0610() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;

        //업무관리정보 유효성 확인
        if (this.getOpCode().equalsIgnoreCase(this.OpCode_start)) {
            logger.info("{} BATCH JOB : start request received", logHeader);
        }
        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_resume)) {
            logger.info("{} BATCH JOB : end request received", logHeader);
        }
        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_unit_end)) {
        }
        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_all_end)) {
        }
        else {
            logger.info("{} 0610 telegram : unknown  Operation code received >> "+this.getOpCode(), logHeader);
            this.setResolveResponseCode(TelegramKeys.BOKJJ_RET_CODE_TEL_CODE_ERROR);

            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = this.getOpCode();
            String errCode = "BECEAIFJI008";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            //응답 전문을 수신한 경우에만 return false
        }
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<7; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=7; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(6);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(9);
    }
}